void effect_spiral(int direction, int iterations, int delay);
void effect_spinning_plane(int direction, int iterations, int delay);
void effect_rain (int iterations, int delay, int hold, int speed);
void sendvoxel_z (unsigned char x, unsigned char y, unsigned char z, int delay);
void sendplane_rand_z (unsigned char z, int delay, int wait);
void blinky(void);
void flyplane (unsigned char plane,unsigned char direction, int delay);
void loadbar(int delay);
void random_1 (int iterations, int voxels, int delay);
void random_2 (void);
void random_filler (int iterations, int pixels, int delay, int state);
void random_filler2 (int delay, int state);
void planeflip (unsigned char axis1, int pos1, unsigned char axis2, int pos2, int delay);
void flip_playback (int delay, unsigned char flip_x, unsigned char flip_y, unsigned char flip_z);
void boingboing (uint16_t iterations, int delay, unsigned char mode, unsigned char drawmode);

// Spirala
void effect_spiral(int direction, int iterations, int delay)
{
	int i;
	int z;

	for (i=0;i<iterations;i++)
	{
		
		for (z=0;z<4;z++)
		{
			// Citim animatia din memoria programului si o punem in bufferul cubului.
			cube[z][0] = (pgm_read_byte(&spinning_line[(i+z)%6][0]) >> 4);
			cube[z][1] = pgm_read_byte(&spinning_line[(i+z)%6][0]);
			cube[z][2] = (pgm_read_byte(&spinning_line[(i+z)%6][1]) >> 4);
			cube[z][3] = pgm_read_byte(&spinning_line[(i+z)%6][1]);
		}
		delay_ms(delay);
	}
}

// spinning plane.
void effect_spinning_plane(int direction, int iterations, int delay)
{
	int i;
	int z;

	for (i=0;i<iterations;i++)
	{
	
		for (z=0;z<4;z++)
		{
			cube[z][0] = (pgm_read_byte(&spinning_line[(i)%6][0]) >> 4);
			cube[z][1] = pgm_read_byte(&spinning_line[(i)%6][0]);
			cube[z][2] = (pgm_read_byte(&spinning_line[(i)%6][1]) >> 4);
			cube[z][3] = pgm_read_byte(&spinning_line[(i)%6][1]);
		}
		delay_ms(delay);
	}
}

// Ploaie
void effect_rain (int iterations, int delay, int hold, int speed)
{
	int i;
	int p;		
	int z;		
	int y;		
	
	fill(0x00);
	
	for (i = 0; i < iterations; i++)
	{
		
		setvoxel(rand()%4,rand()%4,3);
		delay_ms(hold);
		
		
		
		for (p=1;p<4;p++)
		{
			
			for (z=0;z<3;z++)
			{
				for (y=0;y<4;y++)
				{
					cube[z][y] = cube[z+1][y];
				}
			}
			
			
			cube[3][0] = 0x00;
			cube[3][1] = 0x00;
			cube[3][2] = 0x00;
			cube[3][3] = 0x00;
			
			
			
			delay_ms(speed+(speed/p));
		}
		
		fill(0x00);
		delay_ms(delay);
	}
}


void sendvoxel_z (unsigned char x, unsigned char y, unsigned char z, int delay)
{
	int i, ii;
	for (i=0; i<4; i++)
	{
		if (z == 3)
		{
			ii = 3-i;
			clrvoxel(x,y,ii+1);
		} else
		{
			ii = i;
			clrvoxel(x,y,ii-1);
		}
		setvoxel(x,y,ii);
		delay_ms(delay);
	}
}


void sendplane_rand_z (unsigned char z, int delay, int wait)
{
	unsigned char loop = 16;
	unsigned char x, y;

	fill(0x00);

	setplane_z(z);
	
	while(loop)
	{
		x = rand()%4;
		y = rand()%4;
		if (getvoxel(x,y,z))
		{
			
			sendvoxel_z(x,y,z,delay);
			delay_ms(wait);
			loop--; 
		}
	}
}


void sendvoxels_rand_z (int iterations, int delay, int wait)
{
	unsigned char loop = 16;
	unsigned char x, y, last_x, last_y, i;

	fill(0x00);

	
	for (x=0;x<4;x++)
	{
		for (y=0;y<4;y++)
		{
			if (rand()%2 == 0)
			{
				setvoxel(x,y,0);
			} else
			{
				setvoxel(x,y,3);
			}
		}
	}

	for (i=0;i<iterations;i++)
	{
		
		x = rand()%4;
		y = rand()%4;
		
		if (y != last_y && x != last_x)
		{
			
			if (getvoxel(x,y,0))
			{
				
				sendvoxel_z(x,y,0,delay);
			} else
			{
				
				sendvoxel_z(x,y,3,delay);
			}
			delay_ms(wait);
			
			
			last_y = y;
			last_x = x;
		}
	}

}


void random_1 (int iterations, int voxels, int delay)
{
	int i;
	int v;
	for (i = 0; i < iterations; i++)
	{
		for (v=0;v<=voxels;v++)
			setvoxel(rand()%4,rand()%4,rand()%4);
			
		delay_ms(delay);
		fill(0x00);
	}
}


void random_2 (void)
{
	int i;
	
	for (i=1;i<20;i++)
	{
		random_1(5,i,500);
	}
	
	for (i=20;i>=1;i--)
	{
		random_1(5,i,500);
	}
	
}


void random_filler (int iterations, int pixels, int delay, int state)
{
	int i;
	int p;
	for (i = 0; i < iterations; i++)
	{
		for (p=0;p<=pixels;p++)
			altervoxel(rand()%4,rand()%4,rand()%4,state);
			
		delay_ms(delay);
	}
}


void random_filler2 (int delay, int state)
{
	int x,y,z;
	int loop = 0;
	
	while (loop<63)
	{
		x = rand()%4;
		y = rand()%4;
		z = rand()%4;

		if ((state == 0 && getvoxel(x,y,z) == 0x01) || (state == 1 && getvoxel(x,y,z) == 0x00))
		{
			altervoxel(x,y,z,state);
			delay_ms(delay);
			loop++;
		}	
	}
}


void planeflip (unsigned char axis1, int pos1, unsigned char axis2, int pos2, int delay)
{
	
}



void loadbar(int delay)
{
	fill(0x00);
	
	int z,y;
	
	for (z=0;z<4;z++)
	{
		for (y=0;y<4;y++)
			cube[z][y] = 0xff;
			
		delay_ms(delay);
	}
	
	delay_ms(delay*3);
	
	for (z=0;z<4;z++)
	{
		for (y=0;y<4;y++)
			cube[z][y] = 0x00;
			
		delay_ms(delay);
	}
}

void flyplane (unsigned char plane,unsigned char direction, int delay)
{
	int i,ii;
	
	fill(0x00);
	
	for (i=0;i<4;i++)
	{
		if (direction != 0)
		{
			ii = 3-i;
		} else
		{
			ii = i;
		}
		
		setplane(plane,ii,1);
		delay_ms(delay);
		setplane(plane,ii,0);
	}
	
	for (i=2;i>=0;i--)
	{
		if (direction != 0)
		{
			ii = 3-i;
		} else
		{
			ii = i;
		}
		
		setplane(plane,ii,1);
		delay_ms(delay);
		setplane(plane,ii,0);
	}
}

void blinky()
{
	int a;

	fill(0x00);
	delay_ms(2000);
	
	for (a=0;a<3;a++)
	{
		fill(0xff);
		delay_ms(50);
		fill(0x00);
		
		delay_ms(1500);
		
		fill(0xff);
		delay_ms(30);
		fill(0x00);
		
		delay_ms(7000);
	}
	
	
}

void blinky2()
{
	int i,r;
	fill(0x00);
	
	for (r=0;r<5;r++)
	{
		i = 750;
		while (i>0)
		{
			fill(0x00);
			delay_ms(i);
			
			fill(0xff);
			delay_ms(100);
			
			i = i - (15+(1000/(i/10)));
		}
		
		delay_ms(1000);
		
		i = 750;
		while (i>0)
		{
			fill(0x00);
			delay_ms(751-i);
			
			fill(0xff);
			delay_ms(100);
			
			i = i - (15+(1000/(i/10)));
		}
	}

}




void boingboing(uint16_t iterations, int delay, unsigned char mode, unsigned char drawmode)
{
	fill(0x00);		

	int x, y, z;		
	int dx, dy, dz;	
	int lol, i;		
	unsigned char crash_x, crash_y, crash_z;

	
	int snake[8][3];
	for (i=0;i<8;i++)
	{
		snake[i][0] = 4;
		snake[i][1] = 4;
		snake[i][2] = 4;
	}
	
	y = rand()%4;
	x = rand()%4;
	z = rand()%4;
	
	dx = 1;
	dy = 1;
	dz = 1;
	
	while(iterations)
	{
		crash_x = 0;
		crash_y = 0;
		crash_z = 0;
	

		
		if (rand()%3 == 0)
		{
			
			lol = rand()%3;
			if (lol == 0)
				dx = rand()%3 - 1;
			
			if (lol == 1)
				dy = rand()%3 - 1;
				
			if (lol == 2)
				dz = rand()%3 - 1;
		}

	
		if (dx == -1 && x == 0)
		{
			crash_x = 0x01;
			if (rand()%3 == 1)
			{
				dx = 1;
			} else
			{
				dx = 0;
			}
		}
		
		if (dy == -1 && y == 0)
		{
			crash_y = 0x01;
			if (rand()%3 == 1)
			{
				dy = 1;
			} else
			{
				dy = 0;
			}
		}
		
		if (dz == -1 && z == 0)
		{
			crash_z = 0x01;
			if (rand()%3 == 1)
			{
				dz = 1;
			} else
			{
				dz = 0;
			}
		}
			
		if (dx == 1 && x == 3)
		{
			crash_x = 0x01;
			if (rand()%3 == 1)
			{
				dx = -1;
			} else
			{
				dx = 0;
			}
		}
		
		if (dy == 1 && y == 3)
		{
			crash_y = 0x01;
			if (rand()%3 == 1)
			{
				dy = -1;
			} else
			{
				dy = 0;
			}
		}
		
		if (dz == 1 && z == 3)
		{
			crash_z = 0x01;
			if (rand()%3 == 1)
			{
				dz = -1;
			} else
			{
				dz = 0;
			}
		}
		
		
		if (mode | 0x01)
		{
			if (crash_x)
			{
				if (dy == 0)
				{
					if (y == 3)
					{
						dy = -1;
					} else if (y == 0)
					{
						dy = +1;
					} else
					{
						if (rand()%2 == 0)
						{
							dy = -1;
						} else
						{
							dy = 1;
						}
					}
				}
				if (dz == 0)
				{
					if (z == 3)
					{
						dz = -1;
					} else if (z == 0)
					{
						dz = 1;
					} else
					{
						if (rand()%2 == 0)
						{
							dz = -1;
						} else
						{
							dz = 1;
						}
					}	
				}
			}
			
			if (crash_y)
			{
				if (dx == 0)
				{
					if (x == 3)
					{
						dx = -1;
					} else if (x == 0)
					{
						dx = 1;
					} else
					{
						if (rand()%2 == 0)
						{
							dx = -1;
						} else
						{
							dx = 1;
						}
					}
				}
				if (dz == 0)
				{
					if (z == 3)
					{
						dz = -1;
					} else if (z == 0)
					{
						dz = 1;
					} else
					{
						if (rand()%2 == 0)
						{
							dz = -1;
						} else
						{
							dz = 1;
						}
					}	
				}
			}
			
			if (crash_z)
			{
				if (dy == 0)
				{
					if (y == 3)
					{
						dy = -1;
					} else if (y == 0)
					{
						dy = 1;
					} else
					{
						if (rand()%2 == 0)
						{
							dy = -1;
						} else
						{
							dy = 1;
						}
					}	
				}
				if (dx == 0)
				{
					if (x == 3)
					{
						dx = -1;
					} else if (x == 0)
					{
						dx = 1;
					} else
					{
						if (rand()%2 == 0)
						{
							dx = -1;
						} else
						{
							dx = 1;
						}
					}	
				}
			}
		}
		
	
		if (mode | 0x02)
		{
			if (	// cele 8 colturi
				(x == 0 && y == 0 && z == 0) ||
				(x == 0 && y == 0 && z == 3) ||
				(x == 0 && y == 3 && z == 0) ||
				(x == 0 && y == 3 && z == 3) ||
				(x == 3 && y == 0 && z == 0) ||
				(x == 3 && y == 0 && z == 3) ||
				(x == 3 && y == 3 && z == 0) ||
				(x == 3 && y == 3 && z == 3) 				
			)
			{
				
				lol = rand()%3;
				if (lol == 0)
					dx = 0;
				
				if (lol == 1)
					dy = 0;
					
				if (lol == 2)
					dz = 0;
			}
		}
	
		
		x = x + dx;
		y = y + dy;
		z = z + dz;
		
		if (drawmode == 0x01) 
		{
			setvoxel(x,y,z);
			delay_ms(delay);
			clrvoxel(x,y,z);	
		} else if (drawmode == 0x02) 
		{
			flpvoxel(x,y,z);
			delay_ms(delay);
		} if (drawmode == 0x03)
		{
			for (i=7;i>=0;i--)
			{
				snake[i][0] = snake[i-1][0];
				snake[i][1] = snake[i-1][1];
				snake[i][2] = snake[i-1][2];
			}
			snake[0][0] = x;
			snake[0][1] = y;
			snake[0][2] = z;
				
			for (i=0;i<8;i++)
			{
				setvoxel(snake[i][0],snake[i][1],snake[i][2]);
			}
			delay_ms(delay);
			for (i=0;i<8;i++)
			{
				clrvoxel(snake[i][0],snake[i][1],snake[i][2]);
			}
		}
		
	
		iterations--;
	}
}




































